%function [ncfile_name,sss_tsg_cor,tab_0,vbuck_0,sss_tsg_lis,tab_lis,TSG_co,SAL_diff,Points_elimines,COR,erreur_mediane,COR_mediane,datestr_TSG,datestr_Bucket]=correction(tab,vbuck,fic)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Etape 0 : Nettoyage des donnees
% - elimination qd pas de position, pas de salinite, pas de date

% function [tab_0,vbuck_0]=etape0_nett_donnes(tab,vbuck)

tab_01=tab(find(tab(:,9)<datenum(2006,01,01)),:);
tab_02=tab_01(find(tab_01(:,10)<90 & tab_01(:,10)>-90),:);
tab_03=tab_02(find(tab_02(:,11)<180 & tab_02(:,11)>-180),:);
tab_04=tab_03(find(tab_03(:,14)<45 & tab_03(:,14)>1), :);

tab_0=tab_04;

vbuck_0=vbuck(find(vbuck(:,9)<45),:);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ETAPE 1: lissage des mesures TSG
%          methode de la moyenne glissante avec 1h pour l intervalle de temps

% function [sss_tsg_lis,tab_lis]=etape1_lissage_tsg(tab_0) 

 sss_tsg=tab_0(:,14);           % salinite 
 tjmat=tab_0(:,9) ;             % temps 
 inttsg=1/24;                  % intervalle de temps pour la moyenne glissante : 1 heure
 smin=1; smax=45;              %limites acceptables en salinite (psu) 
 ectlim=0.005;
   
for ns = 1:length(sss_tsg)
	cond1 = tjmat>=tjmat(ns)-inttsg/2 & tjmat<tjmat(ns)+inttsg/2 ; % points dans l'intervalle considere
	cond2 = sss_tsg~=9999 ; % exclusion des points aberrants
	is = find(cond1 & cond2) ; in = is ;
	if ~isempty(in)
		ect = Inf ; ectprec = 0 ;
		while ect>ectlim & ect~=ectprec
			ectprec = ect ; 
			ect = std(sss_tsg(in)) ; moy = mean(sss_tsg(in)) ; % ecart-type, moyenne sur l'intervalle
			in = find(sss_tsg(is)>=moy-ect & sss_tsg(is)<=moy+ect) ; in = is(in) ; % indice des points pris en compte
		end
		sss_tsg_lis(ns) = mean(sss_tsg(in));
        tjmat_lis(ns)=tjmat(ns);
	else
		sss_tsg_lis(ns) = 9999 ;
        tjmat_lis(ns)=9999;
	end
end 

tab_lis=tab_0;

tab_lis(:,14)=sss_tsg_lis;
tab_lis(:,9)=tjmat_lis;


figure

plot(tab(:,9),tab(:,14),'color','b','LineWidth',1)
hold on
plot(tab_lis(:,9),tab_lis(:,14),'color','r','LineWidth',1)
hold on
datetick('x',20)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ETAPE 2:  co-location des prelevements et des mesures TSG
%           calcul de la difference donnée Bouteille - donnée TSG en chaque
%           point de co-localisation

% exclusion des points aberrants (ecart trop grand.....  definir par ex:
% SAL_diff>mean(SAL_diff)++3*std(SAL_diff)


% function [TSG_co,SAL_diff,Points_elimines,COR,erreur_mediane,erreur1,erreur2,COR_mediane]=etape3_tsg_co(tab_lis,vbuck_0,tab)


sss_tsg_lis=tab_lis(:,14);       % extraction des données salinité du TSG
tjmat_lis=tab_lis(:,9);
tjmat=tab(:,9);


[rB,cB]=size(vbuck_0);
TSG_co=[0 0 0 0 0];              % initialisation de la matrice de co-localisation
Points_elimines=[0 0 0 0 0];         %points eliminés.....rajouter la position
% on recherche les mesures du TSG qui sont co-localisées avec les
% prélèvements bouteilles +/- 5 minutes (imprecision du temps des
% prélèvements et temps d aquisition du TSG)

for i=1:rB
    A=abs(tab_lis(:,9)-vbuck_0(i,6));
B=find(A==min(A));
cond1=A(min(B))<0.0035;
cond1=A(min(B))>0.0035;
    if  A(min(B))<0.05 & sss_tsg_lis(min(B))~=9999                          % 0.0035 = 5 minutes = durée d echantillonage du TSG
    TSG_co=[TSG_co;[tab_lis(min(B),9) tab_lis(min(B),10) tab_lis(min(B),11) sss_tsg_lis(min(B)) vbuck_0(i,9)]];
    Points_elimines = Points_elimines;
    
    elseif A(min(B))>0.05
    TSG_co=TSG_co;
    Points_elimines = [Points_elimines;[vbuck_0(i,6) tab_lis(min(B),10) tab_lis(min(B),11) vbuck_0(i,9) 9999]]; 
    
    elseif sss_tsg_lis(min(B))==9999
    TSG_co=TSG_co;
    Points_elimines = [Points_elimines;[vbuck_0(i,6) tab_lis(min(B),10) tab_lis(min(B),11) vbuck_0(i,9) 9999]]; 
    
    end
end

[rT,cT]=size(TSG_co);
TSG_co=TSG_co(2:rT,:);                   %TSG_co = [ datenum TSG Bucket]

[rP,cP]=size(Points_elimines);
Points_elimines=Points_elimines(2:rP,:);    

% calcul de la difference entre les deux valeurs de salinite

SAL_diff=TSG_co(:,5)-TSG_co(:,4);                %  Bucket - TSG

TSG_co=[TSG_co SAL_diff]  ;       %   [ datenum TSG Bucket diff ]


% exclusion des points aberrants (ecart trop grand)

A=find(SAL_diff<(median(SAL_diff)+3*std(SAL_diff)));

TSG_co=TSG_co(A,:);

B=find(SAL_diff>(median(SAL_diff)+3*std(SAL_diff)));
C=find(SAL_diff==(median(SAL_diff)+3*std(SAL_diff)));

if ~isempty(B)
Points_elimines=[Points_elimines;[vbuck_0(B,6) tab_lis(B,10) tab_lis(B,11) vbuck_0(B,9) SAL_diff(B)]];
end

if ~isempty(C)
Points_elimines=[Points_elimines;[vbuck_0(C,6) tab_lis(C,10) tab_lis(C,11) vbuck_0(C,9) SAL_diff(C)]];
end

SAL_diff=TSG_co(:,6);

[rT,cT]=size(TSG_co);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Calcul des valeurs médianes de correction:   chaque point de
% comparaison, on attribue la médiane des corrections dans une fenêtre de
% 10 jours. Puis on interpole entre chaque médiane pour avoir la correction
%   appliquer en chaque point de donnée TSG

interv = 10 ;            % fenêtre de temps = 10 jours pour le calcul des valeurs médianes de correction



COR_mediane=[0 0];
erreur_mediane =[0 0];

for ns = 1:length(TSG_co(:,1))
    
    is=find(TSG_co(:,1)>TSG_co(ns,1)-interv/2 & TSG_co(:,1)<TSG_co(ns,1)+interv/2);
    if ~isempty(is)
        COR_mediane=[COR_mediane;[ TSG_co(ns,1) median(TSG_co(is,6))]];
        erreur_mediane=[erreur_mediane;[std(SAL_diff(is))/sqrt(length(is)) length(is)]];
    else COR_mediane=COR_mediane;
         erreur_mediane = erreur_mediane;
    end
end

COR_mediane=COR_mediane(2:length(COR_mediane),:);
erreur_mediane = erreur_mediane(2:length(erreur_mediane),:);


erreur_mediane(find(erreur_mediane(:,2)<4),1)=1;

if COR_mediane(1,1)~=tjmat(1)
COR_mediane=[[tjmat(1) COR_mediane(1,2)];COR_mediane]
end

if COR_mediane(length(COR_mediane),1)~=tjmat(length(tjmat))
COR_mediane=[COR_mediane;[tjmat(length(tjmat)) COR_mediane(length(COR_mediane),2)]];
end


COR=interp1(COR_mediane(:,1),COR_mediane(:,2),tjmat);

erreur_mediane = [TSG_co(:,2:3) erreur_mediane];         % coordonnées des points de comparaison - erreur sur la comparaison en ces points - nombre de prelevements utilisés pour la correction



% function [sss_tsg_cor]=etape4_correction_recherche2(TSG_co,tab,COR)



tjmat=tab(:,9);                 % Vecteur de temps du TSG
sss_tsg=tab(:,14);              % Vecteur de salinité du TSG
tjmat_lis=tab_lis(:,9);
time_co=(TSG_co(:,1));                    % Vecteur de temps des points de comparaison


   
sss_tsg_cor=sss_tsg+COR;           %salinité initiale corrigée
            
           
            
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% representation graphique

figure

plot(tjmat,sss_tsg,'color','b','LineWidth',1)
hold on
plot(tjmat,sss_tsg_cor,'color','r','LineWidth',1)
hold on
scatter(TSG_co(:,1),TSG_co(:,5),100,'+g')
hold on
datetick('x',20)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         
            
            
            

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  trajectoire et prelevements bouteille



LAT=tab_lis(:,10);
LON=tab_lis(:,11);

% LAT_tsg=LAT(find(tab2(:,14)~=NaN));
% LON_tsg=LON(find(tab2(:,14)~=NaN));

LAT_bucket_ok=[TSG_co(:,2)];
LON_bucket_ok=[TSG_co(:,3)];

LAT_bucket_elimines=[Points_elimines(:,2)];       
LON_bucket_elimines=[Points_elimines(:,3)];



latmin = min(LAT) - 10.;
latmax = max(LAT) + 10.;
lonmin = min(LON) - 10. ;
lonmax = max(LON) + 10. ;

figure

m_proj('Equidistant Cylindrical','lat',[latmin latmax],'long',[lonmin lonmax]);
%m_proj('miller','lat',[35 65],'long',[-50 0]);

% trait de cote
m_coast('patch',[0.9 0.9 0.9]);
hold on

m_grid   
hold on

% trait
h1 = m_plot(LON,LAT,'b');
%h2 = m_plot(LON,LAT,'+r','MarkerSize',2);
h3 = m_plot(LON_bucket_ok,LAT_bucket_ok,'+g','MarkerSize',10);
h4 = m_plot(LON_bucket_elimines,LAT_bucket_elimines,'+r','MarkerSize',10);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  variables de sortie supplémentaires

% tab(:,9) : jours juliens matlab: depuis 01/01/0000

datestr_TSG=datestr(1.00001,'yyyymmddHHMMSS');
for i=2:length(tab)
    datestr_TSG=[datestr_TSG;datestr(1.00001,'yyyymmddHHMMSS')];
end

datestr_TSG(find(tab(:,9)<datenum(2006,01,01)),:)=datestr(tab_01(:,9),'yyyymmddHHMMSS');                % date des mesures TSG sous le format 'dd-mmm-yyyy hh:mm:ss'
datestr_Bucket=datestr(vbuck(:,6),'yyyymmddHHMMSS');           % date des prélèvements sous le format 'dd-mmm-yyyy hh:mm:ss'

[nl,nc]=size(vbuck);
[nl_TSG_co,nc_TSG_co]=size(TSG_co);

jj_TSG=tab(:,9) - ones(length(tab),1)*datenum(1950,01,01,0,0,0); % date des mesures TSG en jours juliens depuis 01/01/1950
jj_Bucket=vbuck(:,6) - ones(nl,1)*datenum(1950,01,01,0,0,0); % date des prélèvements en jours juliens depuis 01/01/1950
    
         
ncfile_name = fic;

 

