% TSG-MAIN1
%
% interface traitement TSG
%
% appel des boutons
%
% choix type fichier TSG
%
%  decodage TSG 
%
%  carto
%
% analyse TSVLL vs time
% analyse  TSV - carto 
% analyse TS vs LAT
% analyse TS vs LON

% validation
%
% SGDB
%
%  quit

% $Id$
%
clear all

% repertoire fichier SSS Climato 
global dirSSSCLIM
global dirSSSCLIMAN

% repertoire fichier TSG  ( ASC/TXT/TDM , mat, dat,)
global dirTSG

% nom generique fichier voyage ( sans extension)
global fic
%
% ===========================================
% variables d environnement A DEFINIR 
% les repertoires et extensions  des fichiers TSG  sont dfinis dans setific 

% repertoire fichiers climato SSS
% atalantique 
dirSSSCLIM = '..\SSSAD2\';
% globale annuelle 
dirSSSCLIMAN = '..\SSSlev1\';

% repertoire fichier data BUKKET  ( .BUK ) 
dirBUK = '..\SSSBUCKET\';

% initialiser egalement les repertoires de donnes dans setific
%
% =================================================

% creation fenetre generale
fig0 = figure( 'position',[20 40 200 800],...
               'name','VALIDATION TSG',...
               'tag','fig0',...
               'MenuBar','none');         
%
% ============================================
% definition  container
% units default : normalized
hc1=uipanel('title','LECTURE FICHIER TSG',...
            'position',[0.1 0.75 0.8 0.24])


 
 % %  type fichier  par pop up
 %creation du texte "nom de fichier" 
 text0 = uicontrol( 'parent',hc1,...
                    'style','text',...
                    'ForegroundColor','k',...
                    'unit','normalized',...
                    'position', [0.1 0.8 0.8 0.15],...
                    'string',' Type  fichier TSG  : ',...
                    'HorizontalAlignment','left');
                
 % setific retourne le repertoire et l extension des fichiers TSG a traiter
 % ainsi que lea structure dfile              
 %setific realise egalement un clear all 
 bific=uicontrol('parent',hc1,...
                 'style','popupmenu',...
                 'unit','normalized',...
                   'position',[0.1 0.7 0.8 0.15],...
                   'string',['ASC : thermo V3 ',...
                             '|TXT : Labview old',...
                             '|NEW : traitement Denis',... 
                             '|LAB : Labview new '],...
                   'callback','setific')
%                              '               |TDM  : oracle|RTT : Real Time ',...
%                              '               |COR  : CORIOLIS|LEG  : Legos '],...
                 
  % decodage 
  deco0 = uicontrol( 'parent',hc1,...
                     'style','pushbutton',...
                     'unit','normalized',...
                    'position',[0.1 0.1 0.8 0.15],...
                    'string','LECTURE',...
                    'tag','deco0',...
                    'callback','deco_TS_cb');
                
 % =========================================================
 
 % definition  container
% units default : normalized
hc2=uipanel('title','TRACE',...
            'position',[0.1 0.4 0.8 0.34])

               
                
  % analyse carto 
  cart0 = uicontrol('parent',hc2,...
                    'style','pushbutton',...
                    'unit','normalized',...
                    'position',[0.1 0.8 0.8 0.15],...
                    'string',' TRAJET NAVIRE',...
                    'tag','cart0',...
                    'callback','anal_MAP_cb');
                
  %   analyse TSV  et carto interactive 
  analm = uicontrol('parent',hc2,...
                    'style','pushbutton',...
                    'unit','normalized',...
                    'position',[0.1 0.6 0.8 0.15],...
                    'string','SST-SSS-VITESSE',...
                    'tag','anal0',...
                    'callback','anal_TSVm_cb'); 
                            
  % analyse TSVLL vs t
  anal0 = uicontrol('parent',hc2,...
                    'style','pushbutton',...
                    'unit','normalized',...
                    'position',[0.1 0.4 0.8 0.15],...
                    'string','SST-SSS-VIT-POSITION',...
                    'tag','anal0',...
                    'callback','anal_TSVLL_cb'); 
                
  %
  % analyse TS vs LAT 
  anala = uicontrol('parent',hc2,...
                    'style','pushbutton',...
                    'unit','normalized',...
                    'position',[0.1 0.2 0.8 0.15],...
                    'string','SST-SSS vs LATITUDE',...
                    'tag','analat',...
                    'callback','anal_TSLAT_cb'); 
                
   % analyse TS vs LON 
  analo = uicontrol('parent',hc2,...
                    'style','pushbutton',...
                    'unit','normalized',...
                    'position',[0.1 0.01 0.8 0.15],...
                    'string','SST-SSS vs LONGITUDE',...
                    'tag','analon',...
                    'callback','anal_TSLON_cb');   
  % =========================================================
                
  % definition  container
% units default : normalized
hc3=uipanel('title','VALIDATION',...
            'position',[0.1 0.20 0.8 0.14])
             
  %
  % validation 
  vali0 = uicontrol(  'parent',hc3,...
                     'style','pushbutton',...
                     'unit','normalized',...
                    'position',[0.1 0.6 0.8 0.3],...
                    'string','MODE INTERACTIF',...
                    'tag','vali0',...
                    'callback','vali_TSV_cb');
                
  % Correction 
  core0 = uicontrol( 'parent',hc3,...
                     'style','pushbutton',...
                     'unit','normalized',...
                    'position',[0.1 0.2 0.8 0.3],...
                    'string','CORRECTIONS BOUTEILLES',...
                    'tag','core0',...
                    'callback','core_SSS_cb');
               
                
  % ===========================================%
  % sauv SGDB
  sauv0 = uicontrol( 'style','pushbutton',...
                     'unit','normalized',...
                    'position',[0.1 0.10 0.8 0.05],...
                    'string','ENREGISTRER',...
                    'tag','sauv0',...
                    'callback','sgbd_TS_cb'); 
                
  % creation quitter
  quit0 = uicontrol( 'style','pushbutton',...
                     'unit','normalized',...
                    'position',[0.1 0.03 0.8 0.05],...
                    'string',' QUITTER ',...
                    'callback','quit_cb');
                
     
