% CHARGEMENT CLIMATO GLOBALE ET ANNUELLE
%
% Chargememt dans une matrice du tableau SSS annuel provenant de LEVITUS01
% 
% Code d essai . : Ch. Germain et J. Lefevre ///  20 juillet 2004 ///
%


function [D]=rdsssgla
%----------------------------------------------------
% Charge dans la matrice D les valeurs moyennes climato de salinite


% repertoire fichier SSS Climato annuel 01
global dirSSSCLIMAN

%Le fichier brut contient les donnees sur 33 profondeurs
%les 64 480 (=360*180) premieres valeurs correspondent au niveau 1 (profondeur 0)
%la premiere valeur correspond a la mesure sur le carre de 0 a 1
%deg longitude E et 90 a 89 deg latitude S 
%Les 360 premieres valeurs sont ainsi a latitude constantes pour des  
%longitudes de 0 a 360 deg vers l est.
%Ensuite on recommence pour la latitude entre 89 et 88 deg S
%Apres la 64 480e valeur (soit 6 448 lignes) on passe au niveau 2 et on recommence
%Pour plus de detail voir le fichier readme.htm dans SSSCLIM

fichier = [dirSSSCLIMAN,'s00an1','.txt'];

disp([fichier,'  lecture/decodage  fichier SSS Levitus01 annuel'])
% ouverture fic
fid=fopen(fichier,'r');

% on recupere seulement les donnees au niveau 1
% on range les donnees dans une matrice 180*360

for i=1:180

   [A(:,i),n] = fscanf(fid, '%f %f %f %f %f %f %f %f %f %f',360);

end
  
%on transpose pour replacer lon en col et lat en lig    
D=A';
%la matrice contient alors les donnees de 0 a 360 deg en lon et non pas de -180 a 180!!

% elimination valeur  manquante et terre 
D(find(D==-99.9999))=NaN;
%

fclose(fid);
