function[nbrec,ttt] = rdTSGASC(fichier);

% lecture fichier TSG ASC  THERMO V3 
% decodage et formation tableau N parametres 

% retourne 
% nbrec : nbr record "valides" 
% ttt   : tableau 
%
% lecture ASCII ligne record TSG .. dans line 
% remplissage tableau tab = line
%
% hors valeurs technologique --> NaN
% 1e+36 --> NaN   
%
% formation jour julien  ,  anne, mois , jour, heure , minutes secondes
% passage ddd.ccc 
% init flag sst et sss
%
% probleme du passage annnee ..
%          absence de code fin ( = 6 avec yearf )
%
% in : nom du fichier TSG ASC ( thermo)
% out  : nbrec : nbre de lignes valides du fichier
%      : ttt : tableau ( nbrec,val(1:14))  parametres voyage

%
disp([fichier,'  lecture/decodage ASC :   fichier TSG THERMO V3 '])

% ouverture fichier
fid=fopen(fichier);
%
        % compteur record fichier original
        ienr = 0;
        
        % compteur record lignes  "valide" 
        irec = 0;
        
        % boucle toujours vrai
        while 1
            ienr = ienr+1;      
            % impression 
            if(mod(ienr,1000)==0) disp(ienr);
            end;
     
            %
            % lecture text de la ligne
            tline = fgetl(fid);  
            %disp(tline);
            %
            if ~ischar(tline), break, end
            %
            % passage valeur numerique
            line = str2num(tline);
            %
            icod=line(1);
            %
            switch icod
                case 0 
                    %  pb si yeard est reinitilise l anne suivante !!
                    % le 1er record est suppose bon !!
                    if(ienr==1)  year0 = line(4) 
                    end
                    %
                    % debut d acquisition
%  1     2     3    4                 
% cod   dd   hh.mm  yeard
                    
                    %quand = line(2);
                    %hhcc = line(3);
                    yeard = line(4);
                      
                    disp([num2str(ienr),' record Debut ACQ -  yeard : ',num2str(yeard)])
                    %disp(irec)
                    %disp(line)
                    
                case 2
                % acquisition OK
%  1     2     3     4     5      6    7     8    9    10                   
% cod   dd   hh.mm   dd   hh.mm  lat  lon   sst  sss  xxx
             
                    % increment ligne valide
                    irec = irec+1;
                        
                    % dans tab
                    tab(irec,:) = line;

                case 4
                    % acquisition sans lat-lon
%  1     2     3         4    5    6                   
% cod   dd   hh.mm      sst  sss  xxx
                     irec = irec+1;
                    
                    tab(irec,1:3) = line(1:3);
                    tab(irec,4:7) = NaN;
                    tab(irec,8:10) = line(4:6);    
                   
                case 6
%  1     2     3    4                 
% cod   dd   hh.mm  yearf

                    % fin d acquisition
                    % suppose existant
                    disp(line)
                    %quan = line(2);
                    %hhcc = line(3);
                    yearf = line(4);
                    disp([num2str(ienr),' record Fin  ACQ -  yearf : ',num2str(yearf)])
    
            end
            % 
        end
        %
        fclose(fid);
        
        %statistique lecture
        nbenr = ienr-1;
        nbenr
        disp([num2str(nbenr),' records ASC THERMO lus'])
        %
        nbrec = irec;
        nbrec
        disp([num2str(nbrec),' records valides'])
        %
      
        % crible hors valeurs "technologiques" pour sst et sss 
        %   sstmax = 35. / sstmin = -3.
        %   sssmax = 40. / sssmin = 1.
        %  egalement pour  valeurs 1.E+36 pour sst et sss
        %
        % fonction find  
        % donne les indices des elements differents de zero
        sst = tab(:,8);
        %sst (find(sst > 1.e35)) = NaN;
        sst (find(sst > 36.0 )) = NaN;
        sst (find(sst < -3.0 )) = NaN;
        %
        sss = tab(:,9);
        %sss (find(sss > 1.e35)) = NaN;
        sss (find(sss > 40.0)) = NaN;
        sss (find(sss < 1.0)) = NaN;
        %
        %
        %creation des valeurs matrice finale
   % jour TSG-1 - sortie numerique  - [ yyyy mois jour heure minut sec]
         
        t = to_date(year0,tab(:,2)-1,'n');
        %
        %  init  tyy colonne des annes avec prise en compte 
        % d un  changement d anne
        tyy = ones(nbrec,1)*year0;
    
        % cas ou code 6 manquant en fin de fichier
         %  a rajouter a la paluche !!!!!!
        
        % cas d un voyage sur  annes 
        %  sauf voyage sur 2 ans .. improbable 
          if year0==(yearf-1)
             id=1;
              while tab(id+1,2) >= tab(id,2)
                  id = id+1;
              end
              tyy(id+1:nbrec) = yearf;
         end
    %
    % 
    % code qualite enregistrement
        kod = tab(:,1);
        
    % instant : date - heure
        tmo = t(:,2);
        tdd = t(:,3);
        thh = floor(tab(:,3));
        % en entier .. pour reecriture ASCII 
        tmn = round((tab(:,3) - thh)*100);
        % codage seconde .. inutile .. a zero
        tss = ones(nbrec,1)*0;
             % jour julien ( debut 0 - anne dbut )
        tjd = to_day(year0,tyy,tmo,tdd,thh,tmn);
        
              % jour julien matlab 
        jtim= datenum(tyy,tmo,tdd,thh,tmn,tss);
        
        % passage coordonnes  lat et lon   en  dd.mm  --->  dd.ccc
        lat = tab(:,6);
        lon = tab(:,7);
        lat = degmin2degcent(lat);
        lon = degmin2degcent(lon); 
        
  
         % calcul vitesse 
        % en fait ..  flag vitesse 
        %  nbrec - lat/lon 
        [vit] = cavit (lat,lon,nbrec);
        % retourne vit(1,N) ????
 % ================================================================================================     
  
        % remplissage ttt final
%   1   2       3    4  5   6   7   8   9    10   11  12   13   14   15    16     17     18
% flsst flsss yyyy   mo dd  hh  mn  ss  jd  lat  lon  vit  sst  sss sdsst  sdsss sstcor ssscor
%
       % flag QC sst  et sss  init zero  
        ttt(:,1) = ones(nbrec,1)*0;
        ttt(:,2) = ones(nbrec,1)*0;
        %
        % NB : ttt(:,1) avait t prevu pour ij=kod d caquisition thermo .. inutile 
        
        ttt(:,3) = tyy;
        ttt(:,4) = tmo;
        ttt(:,5) = tdd;
        ttt(:,6) = thh;
        ttt(:,7) = tmn;
        ttt(:,8) = tss;
        
        %modif jour julien matlab ...
        ttt(:,9) = jtim;
        
        ttt(:,10) = lat;
        ttt(:,11) = lon;
        
        % 2 dimensions ???
        ttt(:,12) = vit(:);
        
        ttt(:,13) = sst;
        ttt(:,14) = sss;
%
%       la suite .....
% les valeurs suivantes sont remplis par ailleurs avant sauvegarde .mat