function[nblig,ttt] = rdTSGLAB(fichier);

% lecture fichier TSG  LABview
% decodage et formation tableau 
%
% fichier LABVIEW
% status   A .. trame GPS  OK ( lat - lon  . )
%          V   ...........NOK  pas de lat-lon , SOG COG  mais date - heure OK  
%         NaN  
%
% SSS,SST et COND   peuvenet etre NaN
%
% in : nom du fichier TSGLAB
% out  : nblig : nbre de lignes valides du fichier
%      : ttt : tableau ( nblig,val(1:13))  parametres voyage
%
disp([fichier,'  lecture/decodage  fichier TSG LABVIEW '])

% ouverture fichier
%fid=fopen(fichier);
%

% lcture par textread 
% 10 parametres 
%26.334,35.107,54.617,01/09/2003,08:12:00,A,-15.276930,167.275198,016.1,352.7
% SST    SSS    COND     date      heure  S    LAT       LON       SOG     COG
%[sst,sss,cond,date,heure,status,lat,lon,sog,cog]...
%   = textread( fichier, '%f%f%f%s%s%s%f%f%f%f','delimiter',',','emptyvalue',NaN);

% 21 parametres  ??? 
[sst,sss,cond,date,heure,status,lat,lon,sog,cog,X,X,X,X,X,X,X,X,X,X,X]...
   = textread( fichier, '%f%f%f%s%s%s%f%f%f%f%s%s%s%s%s%s%s%s%s%s%s','delimiter',',','emptyvalue',NaN);

%
% NB : la presence  de NaN .. peut foutre la M...
%  en particulier status .. decoder en %c  !!!!
% 
% dimension 
[nblig,n] = size(sst);

% on recupere l'annee de depart
[j] = sscanf( date{1}, '%2d/%2d/%4d' );
year0 = j(3);

% conversion en decimal
 % et extraction YYYY MM DD HH MN SS 
irec  = 0
% boucle ligne acq 
for i=1 : nblig;
    %
    % impression 
            if(mod(i,1000)==0) disp(i);
%             status(i)
%             date(i)
%             heure(i)
            end;
            
%             status{i}
%             date{i}
%             heure{i}

            %
            % test integrite  status - date - heure
            %   traitement cell   !!!!!
            if( char(status{i}) == 'NaN' )
                % | char(date{i}) == 'NaN')
                %|char( date{i}) == 'NaN' | char(heure{i}) == 'NaN')
                
            % if (char(status{i}) ==  'NaN' )
%                  |  ...
%                  (char(date{i}) == 'NaN' ) | ...
%                  (char(heure{i}) == 'NaN' ) 
    
                 % valeurs a NaN .. y compris tjtim !!!!!
  thh(i,1) = NaN;
  tmn(i,1) = NaN;
  tss(i,1) = NaN;
  tdd(i,1) = NaN;
  tmm(i,1) = NaN;
  tyy(i,1) = NaN;
  tjj(i,1) = NaN;
  tjtim(i,1) = NaN;
                 
             else
                 irec = irec + 1;
            
   %decodage HEURE
  [h] = sscanf( heure{i}, '%2d:%2d:%2d' );
  % decodage JOUR 
  [j] = sscanf( date{i}, '%2d/%2d/%4d' );
  
  thh(i,1) = h(1);
  tmn(i,1) = h(2);
  tss(i,1) = h(3);
  tdd(i,1) = j(1);
  tmm(i,1) = j(2);
  tyy(i,1) = j(3);
  %
  % calcul jour julien
  tjj(i,1) = to_day( year0, [j(3) j(2) j(1) h(1) h(2) h(3)] );
  
  % jour julien matlab
  tjtim(i,1) = datenum(j(3),j(2),j(1),h(1),h(2),h(3));
  
  %tmp = floor(lat(i));
  %lat(i) = ( tmp + ( (lat(i) - tmp )/ 60 ) * 100 ) * lat_sign;
  %tmp = floor(lon(i));
  %lon(i) = ( tmp + ( (lon(i) - tmp )/ 60 ) * 100 ) * lon_sign;
  %
  % si passage ligne chgt de date, on change de repere
% if( lon(i) < 0 ) 
%   lon(i) = lon(i) + 360;

          % fin test integrit
          end
        
        % fin boucle 
    end
    
    % nombre de record valides
    nbrec= irec - 1

  % transpose vecteur jour julien 
  %tjj=tjd'
  
  
        % crible valeurs 1.E+36 pour sst et sss
        % fonction find  
        % donne les indices des elements differents de zero
        %sst = tab(:,8);
        %sst (find(sst > 1.e35)) = NaN;
        %
        %sss = tab(:,9);
        %sss (find(sss > 1.e35)) = NaN;
        %
        
        
        % remplissage ttt final
%   1   2   3    4  5   6   7   8   9    10   11   12   13   14    15     16     17
% cod flag yyyy  mo dd  hh  mn  ss  jd  lat  lon  sst  sss sdsst  sdsss corsst corsss
        ttt(:,1) = ones(nblig,1)*0;
        ttt(:,2) = ones(nblig,1)*0;
        ttt(:,3) = tyy;
        ttt(:,4) = tmm;
        ttt(:,5) = tdd;
        ttt(:,6) = thh;
        ttt(:,7) = tmn;
        ttt(:,8) = tss;
        
        %ttt(:,9) = tjj;
        ttt(:,9) = tjtim;
        
        ttt(:,10) = lat;
        ttt(:,11) = lon;
        ttt(:,12) = sog;
        ttt(:,13) = sst;
        ttt(:,14) = sss;
%
%       la suite .....
