 % rdTSGRT
 function[dim,tab] = rdTSGRT(fichier);
 %
 % lecture decodage fichier TSG temps reel
 %
 % 23456789023456789023456789012345678901234567890
 % HH:MN DD/MM/YYYY LL.LL S LLL.LL S ST.S SS.S
 % 13:00 10/10/2003 22.15 S 166.26 E 24.6 35.6
 %
%
disp([fichier,'  lecture/decodage  fichier TSG  Real Time  '])
 %
 %
 % recup valeurs par textread 
[heure,date,lat,lats,lon,lons,sst,sss]=textread(fichier, '%s%s%f%c%f%c%f%f');

[dim,n] = size(heure);

% elimination valeurs manquantes
   lat (find(lat == 99.99 )) = NaN;
   lon (find(lon == 999.99 )) = NaN;
   sst (find(sst == 999.9 )) = NaN;
   sss (find(sss == 99.99 )) = NaN;

% on recupere l'annee de depart
[j] = sscanf( date{1}, '%2d/%2d/%4d' );
year_base = j(3);

% boucle nbr record 
for i=1 : dim;
    
   % conversion en decimal
    % heure(2) HH MN 
  [h] = sscanf( heure{i}, '%2d:%2d' );
    % date(3)  YYYY MM DD 
  [j] = sscanf( date{i}, '%2d/%2d/%4d' );
     % jour julien
  jj(i) = to_day( year_base, [j(3) j(2) j(1) h(1) h(2) 0] );
  
  if( strcmp( lats(i), 'S' ) )
    lat_sign = -1;
  else lat_sign = 1;
  end
  
  if( strcmp( lons(i), 'W' ) )
    lon_sign = -1;
  else lon_sign = 1; 
  end
  
  % valcul latitude - longitude
  tmp = floor(lat(i));
  lat(i) = ( tmp + ( (lat(i) - tmp )/ 60 ) * 100 ) * lat_sign;
  tmp = floor(lon(i));
  lon(i) = ( tmp + ( (lon(i) - tmp )/ 60 ) * 100 ) * lon_sign;
  
  % passage PAC
   if(lon(i) < -100.) 
       lon(i) = lon(i) + 360.;
   end
   %
   %
    
   % remplissage table tab 
  tab(i,3) = [j(3)];
  tab(i,4) = [j(2)];
  tab(i,5) = [j(1)];
  tab(i,6) = [h(1)]; 
  tab(i,7) = [h(2)]; 
  tab(i,8) = 0.;
  tab(i,9) = jj(i);

  tab(i,10) = lat(i);
  tab(i,11) = lon(i);
 
  tab(i,13) = sst(i);
  tab(i,14) = sss(i); 
  
end

  %
  %   1   2    3    4  5   6   7   8   9    10   11   12   13   14    15    16     17   18
   % cod flag yyyy  mo dd  hh  mn  ss  jd  lat  lon  sst   vit  sss sdsst  sdsss corsst corsss
  
  % calcul (flag) vitesse
  vit=cavit(lat,lon,dim);
 tab(:,12) = vit(:);
